# -*- coding: utf-8 -*-

# This is a simple Hello World Alexa Skill, built using
# the implementation of handler classes approach in skill builder.
import logging

from ask_sdk_core.skill_builder import SkillBuilder
from ask_sdk_core.dispatch_components import AbstractRequestHandler
from ask_sdk_core.dispatch_components import AbstractExceptionHandler
from ask_sdk_core.utils import is_request_type, is_intent_name
from ask_sdk_core.handler_input import HandlerInput

from ask_sdk_model.ui import SimpleCard
from ask_sdk_model import Response

sb = SkillBuilder()

logger = logging.getLogger(__name__)
logger.setLevel(logging.INFO)


class LaunchRequestHandler(AbstractRequestHandler):
	"""Handler for Skill Launch."""
	def can_handle(self, handler_input):
		# type: (HandlerInput) -> bool
		return is_request_type("LaunchRequest")(handler_input)

	def handle(self, handler_input):
		# type: (HandlerInput) -> Response
		speech_text = "Hola, soy la skill de nerfs de Santiago Luna, dime qué pistola quieres."

		handler_input.response_builder.speak(speech_text).set_card(
			SimpleCard("nerfs_santi", speech_text)).set_should_end_session(
			False)
		return handler_input.response_builder.response


class HelloWorldIntentHandler(AbstractRequestHandler):
	"""Handler for Hello World Intent."""
	def can_handle(self, handler_input):
		# type: (HandlerInput) -> bool
		return is_intent_name("elige_nerf")(handler_input)

	def handle(self, handler_input):
		# type: (HandlerInput) -> Response
		speech_text = "toma tu pistolón y vete por ahí"

		handler_input.response_builder.speak(speech_text).set_card(
			SimpleCard("nerfs_santi", speech_text)).set_should_end_session(
			True)
		return handler_input.response_builder.response


class HelpIntentHandler(AbstractRequestHandler):
	"""Handler for Help Intent."""
	def can_handle(self, handler_input):
		# type: (HandlerInput) -> bool
		return is_intent_name("AMAZON.HelpIntent")(handler_input)

	def handle(self, handler_input):
		# type: (HandlerInput) -> Response
		speech_text = "Tienes que decirme qué pistola quieres y te la doy"

		handler_input.response_builder.speak(speech_text).ask(
			speech_text).set_card(SimpleCard(
				"nerfs_santi", speech_text))
		return handler_input.response_builder.response


class CancelOrStopIntentHandler(AbstractRequestHandler):
	"""Single handler for Cancel and Stop Intent."""
	def can_handle(self, handler_input):
		# type: (HandlerInput) -> bool
		return (is_intent_name("AMAZON.CancelIntent")(handler_input) or
				is_intent_name("AMAZON.StopIntent")(handler_input))

	def handle(self, handler_input):
		# type: (HandlerInput) -> Response
		speech_text = "Ok, no pasa nada. Guardo el arsenal"

		handler_input.response_builder.speak(speech_text).set_card(
			SimpleCard("nerfs_santi", speech_text))
		return handler_input.response_builder.response




class SessionEndedRequestHandler(AbstractRequestHandler):
	"""Handler for Session End."""
	def can_handle(self, handler_input):
		# type: (HandlerInput) -> bool
		return is_request_type("SessionEndedRequest")(handler_input)

	def handle(self, handler_input):
		# type: (HandlerInput) -> Response
		return handler_input.response_builder.response


class CatchAllExceptionHandler(AbstractExceptionHandler):
	"""Catch all exception handler, log exception and
	respond with custom message.
	"""
	def can_handle(self, handler_input, exception):
		# type: (HandlerInput, Exception) -> bool
		return True

	def handle(self, handler_input, exception):
		# type: (HandlerInput, Exception) -> Response
		logger.error(exception, exc_info=True)

		speech = "Perdona, no he entendido bien, puedes decirlo de otra forma?"
		handler_input.response_builder.speak(speech).ask(speech)

		return handler_input.response_builder.response


sb.add_request_handler(LaunchRequestHandler())
sb.add_request_handler(HelloWorldIntentHandler())
sb.add_request_handler(HelpIntentHandler())
sb.add_request_handler(CancelOrStopIntentHandler())
sb.add_request_handler(SessionEndedRequestHandler())

sb.add_exception_handler(CatchAllExceptionHandler())

handler = sb.lambda_handler()








